package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.MerchantPackageGoodsService;
import com.gxwebsoft.shop.entity.MerchantPackageGoods;
import com.gxwebsoft.shop.param.MerchantPackageGoodsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商家套餐可使用的商品控制器
 *
 * @author 科技小王子
 * @since 2024-11-20 01:55:04
 */
@Api(tags = "商家套餐可使用的商品管理")
@RestController
@RequestMapping("/api/shop/merchant-package-goods")
public class MerchantPackageGoodsController extends BaseController {
    @Resource
    private MerchantPackageGoodsService merchantPackageGoodsService;

    @ApiOperation("分页查询商家套餐可使用的商品")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantPackageGoods>> page(MerchantPackageGoodsParam param) {
        // 使用关联查询
        return success(merchantPackageGoodsService.pageRel(param));
    }

    @ApiOperation("查询全部商家套餐可使用的商品")
    @GetMapping()
    public ApiResult<List<MerchantPackageGoods>> list(MerchantPackageGoodsParam param) {
        // 使用关联查询
        return success(merchantPackageGoodsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantPackageGoods:list')")
    @ApiOperation("根据id查询商家套餐可使用的商品")
    @GetMapping("/{id}")
    public ApiResult<MerchantPackageGoods> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(merchantPackageGoodsService.getByIdRel(id));
    }

    @ApiOperation("添加商家套餐可使用的商品")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantPackageGoods merchantPackageGoods) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         merchantPackageGoods.setUserId(loginUser.getUserId());
        }
        if (merchantPackageGoodsService.save(merchantPackageGoods)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商家套餐可使用的商品")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantPackageGoods merchantPackageGoods) {
        if (merchantPackageGoodsService.updateById(merchantPackageGoods)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商家套餐可使用的商品")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantPackageGoodsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商家套餐可使用的商品")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantPackageGoods> list) {
        if (merchantPackageGoodsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商家套餐可使用的商品")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantPackageGoods> batchParam) {
        if (batchParam.update(merchantPackageGoodsService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商家套餐可使用的商品")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantPackageGoodsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
